﻿using System;
using Alarus.RealTimeFrameProviding;
using System.Runtime.InteropServices;
using Alarus.Events;

namespace Analyst_PluginExample
{
	[Serializable]
	[AlarusSerializable]
	[GuidAttribute("389EDCE2-54BB-4C2C-9984-51B7516A5DDF")]
	[EventLocalizedName("Test event")]
	[EventTreePath("EventTree.User", "EventTree.Client")]
	[EventSaveable(EventSaveMode.SpecialAndUnifiedLog, "counter")]
	[EventGeneratesAlarmByDefault]
	public class CounterEvent : RawEvent
	{
		[EventFieldSaveableOrScenariesUsable(orderNum: 0, indexable: true)]
		[EventFieldLocalizedName("Counter")]
		private readonly int Counter;

		public CounterEvent(int count)
		{
			Counter = count;
		}

		public override EventTextDescription GetDescription(IToStringConverter converter)
		{
			var eventText = $"Counter = {Counter}";
			var eventDescription = new EventTextDescription(eventText);
			return eventDescription;
		}
	}
}
