﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace HttpInterface
{
	public class JsonEventParser
	{
		public static SubscribedEvent ParseEventFromJsonPayload(IList<string> payload)
		{
			//Example Event
			// {
			// 	"EventId" : "e9e7a69c-7ee2-3fee-a530-9f8a88124fcc",
			// 	"Timestamp" : "25.08.2021 07:43:08",
			// 	"BinaryTimestamp" : "5249340760313445369",
			// 	"ZonedTimestamp" : "25.08.2021 07:43:08.605 +05:00",
			// 	"EventDescription" : "",
			// 	"IsAlarmEvent" : "False",
			// 	"ChannelId" : "00000000-0000-0000-0000-000000000000",
			// 	"ChannelName" : "",
			// 	"Comment" : "KeepAlive"
			// }

			var totalString = string.Join("", payload);
			var separators = new[] { '}' };
			var eventsStrings = totalString.Split(separators, StringSplitOptions.RemoveEmptyEntries);
			var lastEventString = eventsStrings.Last();
			lastEventString = lastEventString.Trim('{');
			separators[0] = '\t';
			var lastEventSplittedStrings = lastEventString.Split(separators, StringSplitOptions.RemoveEmptyEntries);

			var subscribedEvent = new SubscribedEvent
			{
				Description = lastEventSplittedStrings.ToList()
			};

			return subscribedEvent;
		}
	}
}
